package syscon.arbutus.product.services.legal.contract.dto.caseactivity;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import syscon.arbutus.product.services.core.contract.dto.CommentType;
import syscon.arbutus.product.services.core.contract.dto.StampType;

/**
 * Court Activity Type.
 *
 * @author lhan
 */
public class CourtActivityType extends CaseActivityType implements Serializable {

    private static final long serialVersionUID = -6728176700343971740L;
    private static final String category = "COURT";

    /**
     * Indicates the facility where the hearing will take place (e.g. court name, type, room and location).
     * This is a static association to the Facility service. - optional.
     */
    private Long facilityId;

    /**
     * Indicates the facility internal location where the hearing will take place.
     * This is a static association to the Facility service. - optional.
     */
    private Long facilityInternalLocationId;

    /**
     * Indicates the organization where the hearing will take place.
     * This is a static association to the Organization service. - optional.
     */
    private Long organizationId;

    /**
     * Indicates the judge who will be presiding over the court event if applicable.
     * This is just an input field and will have no reference to the Master Names Index (person service) - optional
     */
    private String judge;

    /**
     * The orders that initiated this court event. Static association to the OrderSentence service. - optional
     */
    private Set<Long> orderInititatedIds;

    /**
     * The orders that resulted from this court event. Static association to the OrderSentence service.. - optional
     */
    private Set<Long> orderResultedIds;

    /**
     * Constructor
     */
    public CourtActivityType() {
        super();
    }

    /**
     * Constructor
     *
     * @param caseActivityIdentification Long - Optional when creating. The unique ID for each case related event/activity created in the system. This is a system generated ID.
     * @param activityOccurredDate       Date - The date the case activity occurred. This is NOT the same as a “created date”. - Required
     * @param activityCategory           String - The broad category under which the event is classified. - Required
     * @param activityType               String - The specific event type that falls under the activity category. E.g. Arraignment, Trial, Sentencing - Required
     * @param activityComment            CommentType - Any comments associated with the case event or activity - Optional
     * @param activityOutcome            String - An outcome that may be recorded as a result of the activity - Optional
     * @param outcomeDate                Date - An outcome date records when the activity outcome is recorded or updated. - ignored
     * @param activityStatus             String - The status of the case activity. Required
     * @param chargeIds                  Set<Long> - Indicates the list of charges that are part of the case event. This is a static reference to the Charge service. - Optional
     * @param caseIds                    Set<Long> -  Associations to CaseInfoType objects, at least one. Required
     * @param activityIds                Set<Long> - Associations to either 0 or 2 ActivityType objects. Optional
     * @param caseAffiliationIds         Set<Long> - Associations to CaseAffiliationType objects. Optional
     * @param stamp                      StampType - Ignored - Stamp information is generated by system.
     * @param facilityId                 Long - Indicates the facility where the hearing will take place (e.g. court name, type, room and location). This is a static association to the Facility service. - Optional
     * @param facilityInternalLocationId Long - Indicates the facility internal location where the hearing will take place. This is a static association to the FacilityInternalLocation service. - Optional
     * @param organizationId             Long - Indicates the organization where the hearing will take place. This is a static association to the Organization service. - Optional
     * @param judge                      String - Indicates the judge who will be presiding over the court event if applicable. - Optional
     * @param orderInititatedIds         Set<Long> - The orders that initiated this court event. Static association to the OrderSentence service. - Optional
     * @param orderResultedIds           Set<Long> - The orders that resulted from this court event. Static association to the OrderSentence service.. - Optional
     */
    public CourtActivityType(Long caseActivityIdentification, Date activityOccurredDate, String activityCategory, String activityType, CommentType activityComment,
            String activityOutcome, Date outcomeDate, String activityStatus, Set<Long> chargeIds, Set<Long> caseIds, Set<Long> activityIds, Set<Long> caseAffiliationIds,
            StampType stamp, Long facilityId, Long facilityInternalLocationId, Long organizationId, String judge, Set<Long> orderInititatedIds,
            Set<Long> orderResultedIds) {
        super(caseActivityIdentification, activityOccurredDate, activityCategory, activityType, activityComment, activityOutcome, outcomeDate, activityStatus, chargeIds,
                caseIds, activityIds, caseAffiliationIds, stamp);
        this.facilityId = facilityId;
        this.facilityInternalLocationId = facilityInternalLocationId;
        this.organizationId = organizationId;
        this.judge = judge;
        this.orderInititatedIds = orderInititatedIds;
        this.orderResultedIds = orderResultedIds;

    }

    /**
     * Constructor
     *
     * @param courtActivity CourtActivityType
     */
    public CourtActivityType(CourtActivityType courtActivity) {
        super(courtActivity);
        this.facilityId = courtActivity.getFacilityId();
        this.organizationId = courtActivity.getOrganizationId();
        this.judge = courtActivity.getJudge();
        this.orderInititatedIds = courtActivity.getOrderInititatedIds();
        this.orderResultedIds = courtActivity.getOrderResultedIds();
    }

    /**
     * Indicates the facility where the hearing will take place (e.g. court name, type, room and location).
     * This is a static association to the Facility service.
     *
     * @return the facilityId
     */
    public Long getFacilityId() {
        return facilityId;
    }

    /**
     * Indicates the facility where the hearing will take place (e.g. court name, type, room and location).
     * This is a static association to the Facility service.
     *
     * @param facilityId the facilityId to set
     */
    public void setFacilityId(Long facilityId) {
        this.facilityId = facilityId;
    }

    /**
     * @return the facilityInternalLocationId
     */
    public Long getFacilityInternalLocationId() {
        return facilityInternalLocationId;
    }

    /**
     * @param facilityInternalLocationId the facilityInternalLocationId to set
     */
    public void setFacilityInternalLocationId(Long facilityInternalLocationId) {
        this.facilityInternalLocationId = facilityInternalLocationId;
    }

    /**
     * Indicates the organization where the hearing will take place .
     * This is a static association to the Organization service.
     *
     * @return the organizationId
     */
    public Long getOrganizationId() {
        return organizationId;
    }

    /**
     * Indicates the organization where the hearing will take place .
     * This is a static association to the Organization service.
     *
     * @param organizationId the organizationId to set
     */
    public void setOrganizationId(Long organizationId) {
        this.organizationId = organizationId;
    }

    /**
     * Indicates the judge who will be presiding over the court event if applicable.
     * This is just an input field and will have no reference to the Master Names Index (person service)
     *
     * @return the judge
     */
    public String getJudge() {
        return judge;
    }

    /**
     * Indicates the judge who will be presiding over the court event if applicable.
     * This is just an input field and will have no reference to the Master Names Index (person service)
     * Max length: 128 characters.
     *
     * @param judge the judge to set
     */
    public void setJudge(String judge) {
        this.judge = judge;
    }

    /**
     * The order that initiated this court event. Static association to the OrderSentence service.
     *
     * @return the orderInititatedIds
     */
    public Set<Long> getOrderInititatedIds() {
        if (orderInititatedIds == null) {
            orderInititatedIds = new HashSet<Long>();
        }
        return orderInititatedIds;
    }

    /**
     * The order that initiated this court event. Static association to the OrderSentence service.
     *
     * @param orderInititatedIds the orderInititatedIds to set
     */
    public void setOrderInititatedIds(Set<Long> orderInititatedIds) {
        this.orderInititatedIds = orderInititatedIds;
    }

    /**
     * The order that resulted from this court event. Static association to the OrderSentence service.
     *
     * @return the orderResultedIds
     */
    public Set<Long> getOrderResultedIds() {
        if (orderResultedIds == null) {
            orderResultedIds = new HashSet<Long>();
        }
        return orderResultedIds;
    }

    /**
     * The order that resulted from this court event. Static association to the OrderSentence service.
     *
     * @param orderResultedIds the orderResultedIds to set
     */
    public void setOrderResultedIds(Set<Long> orderResultedIds) {
        this.orderResultedIds = orderResultedIds;
    }

    /**
     * The broad category under which the event is classified.
     * Note that this determines which specific type of activity is created.
     * For CourtActivityType, the code value is always "COURT", other input will be ignored.
     *
     * @return the activityCategory
     */
    @Override
    public String getActivityCategory() {
        return category;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((facilityId == null) ? 0 : facilityId.hashCode());
        result = prime * result + ((facilityInternalLocationId == null) ? 0 : facilityInternalLocationId.hashCode());
        result = prime * result + ((judge == null) ? 0 : judge.hashCode());
        result = prime * result + ((orderInititatedIds == null) ? 0 : orderInititatedIds.hashCode());
        result = prime * result + ((orderResultedIds == null) ? 0 : orderResultedIds.hashCode());
        result = prime * result + ((organizationId == null) ? 0 : organizationId.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (!super.equals(obj)) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        CourtActivityType other = (CourtActivityType) obj;
        if (facilityId == null) {
            if (other.facilityId != null) {
				return false;
			}
        } else if (!facilityId.equals(other.facilityId)) {
			return false;
		}
        if (facilityInternalLocationId == null) {
            if (other.facilityInternalLocationId != null) {
				return false;
			}
        } else if (!facilityInternalLocationId.equals(other.facilityInternalLocationId)) {
			return false;
		}
        if (judge == null) {
            if (other.judge != null) {
				return false;
			}
        } else if (!judge.equals(other.judge)) {
			return false;
		}
        if (orderInititatedIds == null) {
            if (other.orderInititatedIds != null) {
				return false;
			}
        } else if (!orderInititatedIds.equals(other.orderInititatedIds)) {
			return false;
		}
        if (orderResultedIds == null) {
            if (other.orderResultedIds != null) {
				return false;
			}
        } else if (!orderResultedIds.equals(other.orderResultedIds)) {
			return false;
		}
        if (organizationId == null) {
            if (other.organizationId != null) {
				return false;
			}
        } else if (!organizationId.equals(other.organizationId)) {
			return false;
		}
        return true;
    }

    @Override
    public String toString() {
        return "CourtActivityType [facilityId=" + facilityId + ", facilityInternalLocationId=" + facilityInternalLocationId + ", organizationId=" + organizationId
                + ", judge=" + judge + ", orderInititatedIds=" + orderInititatedIds + ", orderResultedIds=" + orderResultedIds + ", getCaseActivityIdentification()="
                + getCaseActivityIdentification() + ", getActivityOccurredDate()=" + getActivityOccurredDate() + ", getActivityType()=" + getActivityType()
                + ", getActivityComment()=" + getActivityComment() + ", getActivityOutcome()=" + getActivityOutcome() + ", getOutcomeDate()=" + getOutcomeDate()
                + ", getActivityStatus()=" + getActivityStatus() + ", getChargeIds()=" + getChargeIds() + ", getCaseIds()=" + getCaseIds() + ", getActivityIds()="
                + getActivityIds() + ", getCaseAffiliationIds()=" + getCaseAffiliationIds() + ", getStamp()=" + getStamp() + "]";
    }

}
